### Persefone.jl - a model of agricultural landscapes and ecosystems in Europe.
###
### Crop model helper functions.
###

function initcropmodel(cropmodel::AbstractString, cropfile::AbstractString, growthfile::AbstractString)
    if cropmodel == "almass"
        Tcroptype = ALMaSS.CropType
        Tcropstate = ALMaSS.CropState
        crops = ALMaSS.readcropparameters(cropfile, growthfile)
    elseif cropmodel == "simple"
        Tcroptype = SimpleCrop.CropType
        Tcropstate = SimpleCrop.CropState
        crops_almass = ALMaSS.readcropparameters(cropfile, growthfile)
        crops = Dict(name => SimpleCrop.CropType(ct.name) for (name, ct) in crops_almass)
    else
        error("initcropmodel: no implementation for crop model '$cropmodel'")
    end
    return crops, Tcroptype, Tcropstate
end

function initfields!(model::SimulationModel, cropmodel::AbstractString)
    if cropmodel == "almass"
        ALMaSS.initfields!(model)
    elseif cropmodel == "simple"
        SimpleCrop.initfields!(model)
    else
        error("initfields! for crop model '$cropmodel'")
    end
end
